<?xml version='1.0' encoding='ISO-8859-1'?> 
<xsl:stylesheet 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:xl="http://www.w3.org/1999/xlink"
xmlns:d="http://docbook.org/ns/docbook"
exclude-result-prefixes="d"
version="1.0">
<!--
module :
transformation docbook en un tracwiki 

original location :
/Users/fplod/SAXO_DIR_ws/SRC/Documentation/xmldoc/saxo_trackwiki.xsl sur aedon.locean-ipsl.upmc.fr

must be followed by awk -f saxo_trackwiki.awk
because I did not yet correctly handle "* text" (with no linefeed)

update :
$Id$
++ voir http://trac-hacks.org/wiki/XsltMacro
++ add menu tags menuchoice, gui*, shortcut, keycombo, etc.
fplod 2008-08-06T09:38:26Z aedon.locean-ipsl.upmc.fr (Darwin)
add qanda tags (see ugly http://forge.ipsl.jussieu.fr/saxo/wiki/FaqSaxo
vs http://forge.ipsl.jussieu.fr/saxo/download/xmldoc/faqsaxo.html)
add programlisting management
fplod 2008-08-11T10:15:40Z aedon.locean-ipsl.upmc.fr (Darwin)
 menu tags in comments because to ugly ... problem with these tags vs item in lists
fplod 2008-04-18T13:01:50Z aedon.locean-ipsl.upmc.fr (Darwin)
pompage de href="http://docbook.sourceforge.net/release/xsl/current/html/xref.xsl
fplod 2008-01-08T16:05:29Z aedon.locean-ipsl.upmc.fr (Darwin)
a commence  prndre tournure
fplod 2007-10-19T08:39:15Z aedon.locean-ipsl.upmc.fr (Darwin)
creation 
cf http://forge.ipsl.jussieu.fr/superbib/wiki/WikiFormatting
et http://www.sagehill.net/docbookxsl/CustomDb5Xsl.html
car 1re xsl pour db5
-->


<!--
xml output with no xml declaration : this is the only way to make xsl:copy-of copy
nodes instead of contents of nodes
-->
<xsl:output method="xml" 
indent="no" 
omit-xml-declaration="yes"/>

<xsl:strip-space elements="d:article d:sect1 d:sect2 d:sect3 d:sect4 d:variablellist d:itemizedlist d:listitem d:varlistentry d:term d:para d:simpara"/>

<xsl:template match="/">
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:article/d:title">
<!-- pour ajouter une table des matires 
d'aprs
http://groups.google.com/group/trac-users/browse_thread/thread/2c2cf9830c190a7d#e0a71ce3da67fb53
-->
 <xsl:text>= </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> =</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>[[PageOutline]]</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect1/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ==</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:qandadiv/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ==</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect2/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:variable name="newtitle">
  <xsl:call-template name="replace-string">
   <xsl:with-param name="text" select="normalize-space(.)"/>
   <xsl:with-param name="replace" select="'&gt;'"/>
<!-- do not how to write > instead of &gt; ++. need sed features --> 
   <xsl:with-param name="with" select="'&gt;'"/>
  </xsl:call-template>
 </xsl:variable>
 <xsl:text>=== </xsl:text><xsl:value-of select="$newtitle"/><xsl:text> ===</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:qandaentry/d:question/d:para">
 <xsl:text>&#xA;</xsl:text>
 <xsl:variable name="newtitle">
  <xsl:call-template name="replace-string">
   <xsl:with-param name="text" select="normalize-space(.)"/>
   <xsl:with-param name="replace" select="'&gt;'"/>
<!-- do not how to write > instead of &gt; ++. need sed features --> 
   <xsl:with-param name="with" select="'&gt;'"/>
  </xsl:call-template>
 </xsl:variable>
 <xsl:text>=== </xsl:text><xsl:value-of select="$newtitle"/><xsl:text> ===</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect3/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>==== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ====</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect4/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>===== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> =====</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect5/title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>====== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ======</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect2/d:simplesect/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>==== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ====</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:systemitem">
 <xsl:text>{{{</xsl:text><xsl:value-of select="."/><xsl:text>}}}</xsl:text>
</xsl:template>

<xsl:template match="d:para/d:command">
 <xsl:text>{{{</xsl:text><xsl:value-of select="."/><xsl:text>}}}</xsl:text>
</xsl:template>

<xsl:template match="d:filename">
 <xsl:choose>
  <xsl:when test="local-name(..)='userinput'">
   <xsl:value-of select="."/>
  </xsl:when>
  <xsl:otherwise>
   <xsl:text>{{{</xsl:text><xsl:value-of select="."/><xsl:text>}}}</xsl:text>
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<xsl:template match="d:varname">
 <xsl:text>{{{</xsl:text><xsl:value-of select="."/><xsl:text>}}}</xsl:text>
</xsl:template>

<xsl:template match="d:literallayout">
 <xsl:text>{{{</xsl:text><xsl:apply-templates/><xsl:text>}}}</xsl:text>
</xsl:template>
<xsl:template match="d:literal">
 <xsl:text>{{{</xsl:text><xsl:apply-templates/><xsl:text>}}}</xsl:text>
</xsl:template>

<xsl:template match="d:screen">
 <!-- 
we open an HTML block because it is not possible to have font effect (bold, italic) using TracWiki
 -->
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>{{{</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>#!html</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <pre class="screen">
 <xsl:apply-templates/>
 </pre>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>}}}</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:programlisting">
 <!-- 
we open an HTML block because it is not possible to have font effect (bold, italic) using TracWiki
 -->
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>{{{</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>#!html</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <pre class="screen">
 <xsl:apply-templates/>
 </pre>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>}}}</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:screen/d:prompt">
<code class="prompt"><xsl:value-of select="."/></code>
</xsl:template>

<xsl:template match="d:screen/d:userinput">
<strong class="userinput"><code><xsl:apply-templates/></code></strong>
</xsl:template>

<xsl:template match="d:screen/d:userinput/d:command">
<span><strong class="command"><xsl:value-of select="."/></strong></span>
</xsl:template>

<xsl:template match="d:screen/d:userinput/d:option">
<code class="option"><xsl:value-of select="."/></code>
</xsl:template>

<xsl:template match="d:screen/d:computeroutput">
<code class="computeroutput"><xsl:value-of select="."/></code>
</xsl:template>

<xsl:template match="d:screen/d:userinput/d:parameter">
<em class="parameter"><code><xsl:apply-templates/></code></em>
</xsl:template>

<xsl:template match="d:blockquote">
  <xsl:text>  </xsl:text><xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:itemizedlist/d:listitem/d:simpara/d:link[@xl:href]">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text> [</xsl:text><xsl:value-of select="@xl:href"/> <xsl:text> </xsl:text><xsl:value-of select="."/> <xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:variablelist/">
 <xsl:text>&#xA;</xsl:text>
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:variablelist/d:varlistentry/d:listitem/d:simpara/d:link[@xl:href]">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text> [</xsl:text><xsl:value-of select="@xl:href"/> <xsl:text> </xsl:text><xsl:value-of select="."/> <xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:quote">
  <xsl:text>"</xsl:text><xsl:value-of select="."/><xsl:text>"</xsl:text>
</xsl:template>

<xsl:template match="d:itemizedlist/d:listitem">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text> @star@ </xsl:text><xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:imagedata[@fileref]">
<!--
ex : [[Image(source:/trunk/SRC/Documentation/xmldoc/images/showfig.png)]] 
-->
<xsl:text>[[Image(source:/trunk/SRC/Documentation/xmldoc/</xsl:text><xsl:value-of select="@fileref"/><xsl:text>)]]</xsl:text>
</xsl:template>

<xsl:template match="d:link[@xl:href]">
<xsl:variable name="link">
 <xsl:choose>
  <xsl:when test="contains(@xl:href,'firststeps.html')">
   <xsl:text>wiki:FirstSteps</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'all_plots.html')">
   <xsl:text>wiki:AllPlots</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'faqsaxo.html')">
   <xsl:text>wiki:FaqSaxo</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'getsaxo.html')">
   <xsl:text>wiki:GetSaxo</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'infoupdatecm.html')">
   <xsl:text>wiki:InfoUpdateCm</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'infoupdatekwd.html')">
   <xsl:text>wiki:InfoUpdateKwd</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'mailing.html')">
   <xsl:text>wiki:Mailing</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'mini_notice.html')">
   <xsl:text>wiki:MiniNotice</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'tiplink.html')">
   <xsl:text>wiki:TipLink</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'updatesaxo.html')">
   <xsl:text>wiki:UpdateSaxo</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'whatissaxo.html')">
   <xsl:text>wiki:WhatisSaxo</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'whatsnew.html')">
   <xsl:text>wiki:WhatsNew</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'websaxo.html')">
   <xsl:text>wiki:WikiStart</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'../../')">
   <xsl:text>source:/trunk/SRC/</xsl:text><xsl:value-of select="substring-after(@xl:href,'../../')"/>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'idldoc_html_output')">
 <xsl:text>http://forge.ipsl.jussieu.fr/saxo/download/idldoc_html_output/</xsl:text><xsl:value-of select="substring-after(@xl:href,'idldoc_html_output/')"/>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'idlfiles/')">
 <xsl:text>source:/trunk/SRC/Documentation/xmldoc/idlfiles/</xsl:text><xsl:value-of select="substring-after(@xl:href,'idlfiles/')"/>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'figpng/')">
   <xsl:text>source:/trunk/SRC/Documentation/xmldoc/figpng/</xsl:text><xsl:value-of select="substring-after(@xl:href,'figpng/')"/>
  </xsl:when>
  <xsl:otherwise>
   <xsl:value-of select="@xl:href"/>
  </xsl:otherwise>
 </xsl:choose>
</xsl:variable>
<xsl:text>[</xsl:text><xsl:value-of select="$link"/> <xsl:text> </xsl:text><xsl:value-of select="."/> <xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:quote">
  <xsl:text>"</xsl:text><xsl:value-of select="."/><xsl:text>"</xsl:text>
</xsl:template>

<xsl:template match="d:email">
<xsl:text>[mailto:</xsl:text><xsl:value-of select="."/> <xsl:text> </xsl:text><xsl:value-of select="."/> <xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:variablelist/d:varlistentry/d:term">
 <xsl:text>'''</xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text>'''</xsl:text>
</xsl:template>

<xsl:template match="d:emphasis">
  <xsl:text>''</xsl:text><xsl:value-of select="."/><xsl:text>''</xsl:text>
</xsl:template>

<xsl:template match="d:emphasis[@role='bold']">
 <xsl:text>'''</xsl:text><xsl:value-of select="."/><xsl:text>'''</xsl:text>
</xsl:template>

<xsl:template match="d:caution">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>'''Caution'''</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:note">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>'''Note'''</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:replaceable">
 <xsl:choose>
  <xsl:when test="local-name(..)='userinput'">
   <code class="replaceable"><xsl:value-of select="."/></code>
  </xsl:when>
  <xsl:when test="local-name(..)='parameter'">
   <code class="replaceable"><xsl:value-of select="."/></code>
  </xsl:when>
  <xsl:otherwise>
   <xsl:text>'''''</xsl:text><xsl:value-of select="."/><xsl:text>'''''</xsl:text>
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<xsl:template match="d:superscript">
  <xsl:text>^</xsl:text><xsl:value-of select="."/><xsl:text>^</xsl:text>
</xsl:template>

<xsl:template match="d:subscript">
  <xsl:text>,,</xsl:text><xsl:value-of select="."/><xsl:text>,,</xsl:text>
</xsl:template>

<xsl:template match="d:simplelist">
<!-- but beware of links inside -->
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>{{{</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>#!docbook</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:copy-of select="."/>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>}}}</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:informaltable">
<!-- but beware of links inside -->
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>{{{</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>#!docbook</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:copy-of select="."/>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>}}}</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<!-- ++ pb when in listitem/para
<xsl:template match="d:menuchoice|d:guimenu|d:guisubmenu">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>{{{</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>#!docbook</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:copy-of select="."/>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>}}}</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>
-->

<xsl:template match="d:informaltable">
<!-- but beware of links inside -->
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>{{{</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>#!docbook</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:copy-of select="."/>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>}}}</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:link[@linkend]"> 
 <xsl:variable name="target" select="key('id',@linkend)[1]"/>
 <xsl:text>[#</xsl:text><xsl:value-of select="translate(normalize-space(//*[normalize-space(@xml:id='$target')]/d:title),' ','')"/><xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:xref"> 
  <xsl:variable name="target" select="key('id',@linkend)[1]"/>
  <xsl:text>[#</xsl:text><xsl:value-of select="translate(normalize-space(//d:sect1[normalize-space(@xml:id='$target')]/d:title),' ','')"/><xsl:text> </xsl:text> <xsl:value-of select="normalize-space(//d:sect1[normalize-space(@xml:id='$target')]/d:title)"/><xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:callout"> 
 <xsl:text>[[Image(source:/trunk/SRC/Documentation/xmldoc/images/callouts/</xsl:text><xsl:value-of select="position() div 2"/><xsl:text>.png)]]</xsl:text><xsl:apply-templates/>
</xsl:template>

<xsl:template name="replace-string">
<!-- from http://www.dpawson.co.uk/xsl/sect2/replace.html -->
    <xsl:param name="text"/>
    <xsl:param name="replace"/>
    <xsl:param name="with"/>
    <xsl:choose>
      <xsl:when test="contains($text,$replace)">
        <xsl:value-of select="substring-before($text,$replace)"/>
        <xsl:value-of select="$with"/>
        <xsl:call-template name="replace-string">
          <xsl:with-param name="text"
select="substring-after($text,$replace)"/>
          <xsl:with-param name="replace" select="$replace"/>
          <xsl:with-param name="with" select="$with"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$text"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

<!-- do not reproduce the followings elements -->
<xsl:template match="d:mediaobject/d:textobject"/>
<xsl:template match="d:info/d:authorgroup"/>
<xsl:template match="d:info/d:revhistory"/>
<xsl:template match="d:info/d:pubdate"/>
<xsl:template match="d:keywordset"/>

</xsl:stylesheet>  
